// Filename: app.js
define([
        'jquery',
        'underscore',
        'backbone',
        'js/router',
        'helpers/configHelper',
        'sharedhelpers/dateTimeHelper',
        'globalize',
        'globalizeCultures'
], function ($, _, Backbone, Router) {
    var initialize = function () {
        // Pass in our Router module and call it's initialize function

        // global colections, to hold data and avoid unnecesary ajax calls
        window.ObjectCollections = { TheaterCollection: {}, AbridgedTheaterCollection: {}, MovieCollection: {}, ConcessionCollection: {}, CachedMovies: {} };

        // Global models, to hold data and avoid unnecesary ajax calls
        window.ObjectModels = { OrderModel: null };

        //Global App Properties - values should be updated over the app flow
        window.AppProperties = { SearchUnit: null, SelectedTheater: null, SelectedTheaterByZip: null, SelectedPerformance: null, CurrentPosition: null, Language: appConfig.Language, PageRefresh: null, SelectSeatsFragment: null, IsAndroid: null, IsAndroid4x: null, IsAndroidKitKat: null, IsIOS: null, iOSVersion: '', PassbookAvailable: { loyaltyPass: false, ticketPass: false, virtualGiftCardPass: false, dualCardPass: false }, CityOrZipSearch: null, ShowTheaterDistance: null, searchRadius: null, HistoryOrders: null, HistoryOrderIndex: null, TapEvent: null, FBValid: null, nativeBackButton: false, isTouchIdAvailable: false };

        window.ConcessionData = { CurrentModifier: 0, TotalModifiersCount: 0, ComboProductsCount: 0, CurrentComboProduct: 0, ComboItemProducts: [], ParentName: null };
        window.TempConcessionsObjects = [];
        window.TempComboConcessionObject = {};
        window.myhistory=[];

        window.Views = { HomeView: null };

        window.AppMethods = { ChangePage: null };

        window.AppMethods.ChangePage = function (page, refresh, offline) {
            var localize = window.ObjectCollections.Localization.result;

            if (!offline && ConfigHelper.isDeviceOnline() === false && page !== '' && page !== '#home') {
                window.hidePageLoadingMessage();
                window.showAlert(localize.errorUnableConnectToInternet);

                return false;
            }
            Backbone.history.fragment = null;
            if (refresh)
                Backbone.history.navigate(page, { trigger: true, replace: true });
            else
                Backbone.history.navigate(page, true);
        };

        Router.initialize();
    };

    return {
        initialize: initialize
    };
});
