﻿define(['collections/bannerCollection'],
    function (bannerCollection) {
        window.BannerHelper = function () {
            var availableBanners = new bannerCollection();
            function _generateSplashScreenHtml() {
                var container = $('<div>').addClass('splash-screen-banner-container');
              var hrefDiv = $('<div>').addClass('spash-screen-link');
                container.append($('<div>').addClass('splash-screen-banner-close'));
                container.append($('<img>').addClass('splash-screen-banner'));
               container.append(hrefDiv);

                return container;
            }

            function _initializeSplashScreen() {
                if (window.appConfig.UseSplashScreenBanner) {
                    $('body').prepend(_generateSplashScreenHtml());

                    var bannerContainer = $('body').find('.splash-screen-banner-container');
                    var bannerImage = $('body').find('.splash-screen-banner');
                    var bannerClose = $('body').find('.splash-screen-banner-close');
                    var bannerLink = $('body').find('.splash-screen-link');

                    bannerContainer.css('pointer-events', 'auto');

                    bannerClose.on('click', function (e) {
                        bannerContainer.fadeOut(200, function () {
                            $('body').css('pointer-events', '');
                            $(this).remove();
                        });
                    });

                    var fromlocalstorage; //boolean to determine if data is being picked up from localstorage

                    if (localStorage['ncr_storageProvider_bannerCollection']) {
                        require(['sharedhelpers/storageProvider'], function () {
                                           var storage = new StorageProvider();
                                               storage.read('bannerCollection', function (availableBanners) {
                                                  fromlocalstorage = true;
                                                  successCallback(availableBanners, "success", null);
                                                  console.log("Fetched from local storage");

                                              });
                                          });
                           }

                        else { MakeAGetCall(); }

                        function MakeAGetCall() {
                            availableBanners.refreshFromServer({
                                success: successCallback || function () { },
                                error: errorCallback || function () { }
                            })
                                  .then(function (data) {
                                      require(['sharedhelpers/storageProvider'], function () {
                                          var storage = new StorageProvider();
                                          storage.store('bannerCollection', data.result);
                                      });
                                  });
                        }


                        //success callback for getbanners:
                        function successCallback(data, result, xhr) {
                            if (!fromlocalstorage) {                      //need to add response data to collection
                                   availableBanners.reset(data.result);
                            }
                            else
                                availableBanners.reset(data);
                            var splashScreenBanner = availableBanners.getRandomBanner('splashScreen');

                            if (splashScreenBanner) {
                                $('body').css('pointer-events', 'none');

                                var multiplyingFactor;
                                // Hide banner after 'displayDuration' period expiers
                                multiplyingFactor = splashScreenBanner.get('displayDuration') * 1000;

                                //Hide splash screen and show close button on image load
                                bannerImage.load(function () {
                                    bannerContainer.on('touchmove', function (event) {
                                        event.stopPropagation();
                                        event.preventDefault();
                                        return;
                                    });

                                    bannerClose.show();
                                    //if (navigator.splashscreen)
                                    //    navigator.splashscreen.hide();
                                    _.delay(function () {
                                        bannerContainer.fadeOut(200, function () {
                                            $('body').css('pointer-events', '');
                                            $(this).remove();
                                        })
                                    }, multiplyingFactor);
                                });

                                //If we fail to load the image, remove the image and hide the splash screen
                                bannerImage.get(0).onerror = function () {
                                    $('body').css('pointer-events', '');
                                    $(this).remove();

                                    //if (navigator.splashscreen)
                                    //    navigator.splashscreen.hide();
                                };

                                bannerImage.attr('src', splashScreenBanner.get('imageUrl'));

                                if (!$.trim(splashScreenBanner.get('hyperlink'))) {
                                    return;
                                }

                                // Open 'url' when tapped on bottom portion of image
                                bannerLink.on('tap', function (e) {
                                   e.stopPropagation();

                                    var inAppWin = window.open(splashScreenBanner.get('hyperlink'), '_blank');

                                    inAppWin.addEventListener('loadstart', function () {
                                        bannerContainer.remove();
                                    });

                                    inAppWin.addEventListener('exit', function () {
                                       $('body').css('pointer-events', '');
                                        inAppWin.removeEventListener('exit');
                                        inAppWin.removeEventListener('loadstart');
                                        inAppWin = null;
                                    });
                                });

                            } else {
                                //if (navigator.splashscreen) {
                                //    navigator.splashscreen.hide();
                                //}

                                bannerContainer.remove();
                            }

                        }
                        //error call back for get:
                        function errorCallback() {
                            //if (navigator.splashscreen) {
                            //    navigator.splashscreen.hide();
                            //}

                            bannerContainer.remove();
                        }



                    return;
                }

                //taking care that the phonegap splash screen is not being handled manually.
                //if (navigator.splashscreen) {
                //    navigator.splashscreen.hide();
                //}

               //_getBanners();
            }

            function _addBanner() {
                _.defer(function () {
                    var banner = availableBanners.getRandomBanner('banner');
                    if (banner) {
                        var bannerContainer = $('body').pagecontainer('getActivePage').find('.ui-content').find('.banner-container');
                        var bannerImage = $('<img>');
                        bannerImage.data('hyperlink', banner.get('hyperlink'));
                        bannerContainer.show();
                        bannerContainer.html(bannerImage);
                        bannerImage.attr('src', banner.get('imageUrl'));

                        if (!$.trim(banner.get('hyperlink'))) {
                            return;
                        }

                        bannerImage.on('tap', function () {
                            var inAppWin = window.open(banner.get('hyperlink'), '_blank');

                            inAppWin.addEventListener('exit', function () {
                                inAppWin.removeEventListener('exit');
                                inAppWin = null;
                            });
                        });
                    } else {
                        $('body').pagecontainer('getActivePage').find('.ui-content').find('.banner-container').hide();
                    }
                    GetLatestDataFromServer();
                }
                );
            }

            function GetLatestDataFromServer() {
                availableBanners.refreshFromServer({
                    success: function (data) {
                        require(['sharedhelpers/storageProvider'], function () {
                            var storage = new StorageProvider();
                            storage.store('bannerCollection', data.result);
                        });
                    },
                    error: function () { console.log("Failed to get the latest data from server");}
                })
            }


            function _isBannerAvailable() {
                return _.any(availableBanners.models, function (model) {
                    return !model.get('isSplashScreen');
                });
            }

            return {
                initializeSplashScreen: _initializeSplashScreen,
                addBanner: _addBanner,
                isBannerAvailable: _isBannerAvailable
            };
        }();
    });
