﻿window.GoogleAnalyticsHelper = (function () {
    var that = this;
    var localize = window.ObjectCollections.Localization.result;

    var pageTitles = {
        'checkoutSummary': localize.orderSummaryTitle,
        'concessionItem': localize.concessions,
        'concessionModifiersMulti': localize.concessions,
        'concessionModifiersSingleById': localize.concessions,
        'concessions': localize.concessions,
        'confirmHoldSeats': localize.confirmHoldSeats,
        'holdSeats': localize.holdSeats,
        'home': localize.home,
        'loyaltyCardDetails': localize.loyaltyCard,
        'loyaltyCardPage': localize.loyaltyCard,
        'loyaltyCardSignup': localize.loyaltyCardSignupTitle,
        'loyaltyCardSignupStep2': localize.loyaltyCardSignupTitle,
        'loyaltyCardSignupFinalStep': localize.loyaltyCardSignupTitle,
        'myTicketView': localize.purchaseCompleteTitle,
        'paymentMethod': localize.checkoutTitle,
        'paymentMethodSettings': localize.settingsTitle,
        'purchaseHistoryOrderDetails': localize.purchaseOrderDetailsTitle,
        'giftPickup': localize.purchaseHistoryTitle,
        'promotions': localize.promotions,
        'purchaseHistory': localize.purchaseHistoryTitle,
        'selectRecipient': localize.selectRecipient,
        'selectSeats': localize.selectSeatsTitle,
        'settings': localize.settingsTitle,
        'virtualGiftCard': localize.virtualGiftCard,
        'theaters': localize.theatersTitle,
        'theaterDetails': localize.theaterDetailsTitle,
        'listMovies': localize.moviesListTitle,
        'movieDetails': localize.movieDetailsTitle,
        'selectTickets': localize.selectTicketsTitle
    };

    function _getUserPermission(callback) {
        require(['sharedhelpers/storageProvider'], function () {
            var storage = new StorageProvider();
            var googleAnalyticsAllowed = 'googleAnalyticsAllowed';

            storage.read(googleAnalyticsAllowed, function (value) {
                if (value == true) {
                    callback();
                    return;
                }

                if (value == null) {
                    var permissionCallback = function (button) {
                        //Allow = 1; Deny = 2
                        storage.store(googleAnalyticsAllowed, button == 1);

                        if (button == 1) {
                            callback();
                        }
                    };

                    navigator.notification.confirm(localize.googleAnalyticsPrompt, permissionCallback, localize.alertTitle, localize.allow + ', ' + localize.deny);
                }
            });
        });
    };

    function _initialize() {
        if (window.GA && window.appConfig.GoogleAnalyticsId) {
            var startPlugin = function () {
                window.GA.startTrackerWithId(window.appConfig.GoogleAnalyticsId);
                that.gaPlugin = window.GA;
            };
            _getUserPermission(startPlugin);
        }
    };

    function _trackPage(route) {
        if (that.gaPlugin) {
            var visitedPage = pageTitles[route];

            if (visitedPage) {
                that.gaPlugin.trackView(visitedPage);
            }
        }
    };

    function _trackAjaxError(error) {
        if (that.gaPlugin) {
            that.gaPlugin.trackEvent('Exceptions', 'Ajax errors', error, 1);
        }
    };

    function _trackJSError(error) {
        if (that.gaPlugin) {
            that.gaPlugin.trackEvent('Exceptions', 'JS errors', error, 1);
        }
    };

    return {
        initialize: _initialize,
        trackPage: _trackPage,
        trackAjaxError: _trackAjaxError,
        trackJSError: _trackJSError
    };
})();