﻿define(['helpers/uiHelper'], function () {
    window.NativeCalendarHelper = (function () {
        var localize = window.ObjectCollections.Localization.result;

        function _createEvent(options, success, error) {
            window.plugins.calendar.createEvent(options.title, options.location, options.notes, options.startDate, options.endDate, success, error);
        }

        function _addToCalendar(calendarInfo, successCallback)
        {
            var errorCallback = function (message) {
                //default message from plugin when native Calendar is disabled. Do not change it! 
                if (message == 'No default calendar found. Is access to the Calendar blocked for this app?') {
                    window.showAlert(localize.calendarDisabledMessage);
                } else {
                    window.showAlert(localize.calendarError);
                }
            };

            _createEvent(calendarInfo, successCallback, errorCallback);
        }

        function _useCalendarPlugin() {
            return window.plugins && window.plugins.calendar;
        }

        return {
            addToCalendar: _addToCalendar,
            useCalendarPlugin: _useCalendarPlugin
        };
    });
})