﻿
define([
	'sharedhelpers/storageProvider'
], function () {
    window.TheatersHelper = (function () {
        var storage = new StorageProvider();
        var theaterKey = 'TheaterDefaultId';
        var favoriteKey = 'FavoriteTheaters';

        function _saveTheaterDefaultId(value) {
            storage.store(theaterKey, value);
        }

        function _getTheaterDefaultId(callback) {
            storage.read(theaterKey, function (value) {
                callback(value);
            });
        }

        function _getFavoriteTheaters(callback) {
            storage.read(favoriteKey, function (value) {
                value = value || [];
                callback(value);
            });
        }

        function _markTheaterAsFavorite(id, add) {
            _getFavoriteTheaters(function (value) {
                var index = value.indexOf(id);

                if (add) {
                    if (index < 0) {
                        value.push(id);
                    }
                } else {
                    if (index >= 0) {
                        value.splice(index, 1);
                    }
                }

                storage.remove(favoriteKey);
                storage.store(favoriteKey, value);
            });
        }
        return {
            saveTheaterDefaultId: _saveTheaterDefaultId,
            getTheaterDefaultId: _getTheaterDefaultId,
            markTheaterAsFavorite: _markTheaterAsFavorite,
            getFavoriteTheaters: _getFavoriteTheaters
        };
    });
})