﻿define(['sharedhelpers/storageProvider'
], function () {
    window.TouchIdHelper = (function () {
        var localize = window.ObjectCollections.Localization.result;

        function _isTouchIdAvailable(callback) {
            if (window.plugins && window.plugins.touchid) {
                window.plugins.touchid.isAvailable(function () {
                    callback(true);
                }, function () {
                    callback(false);
                });
            } else {
                callback(false);
            }
        }

        function _confirm(button, continueFlow, passwordDialog) {
            var storage = new StorageProvider();
            storage.store('TouchID', button == 1);

            if (button != 1) {
                passwordDialog();
            } else {
                window.plugins.touchid.verifyFingerprint(localize.touchIdScanFingerprint, function () {
                    continueFlow();
                }, function (response) {
                    //user canceled the dialog
                    if (response.code == '-2') {
                        return;
                    }
                    passwordDialog();
                });
            }
        }

        function _verifyFingerprint(continueFlow, passwordDialog) {
            var storage = new StorageProvider();
            var callback = function (isAvailable) {
                if (!isAvailable) {
                    passwordDialog();
                    return;
                }

                storage.read('TouchID', function (value) {
                    if (value == null) {
                        navigator.notification.confirm(
                            localize.touchIdConfirmation,
                            function (buttonIndex) {
                                _confirm(buttonIndex, continueFlow, passwordDialog);
                            },
                            localize.touchId,
                            localize.ok + ', ' + localize.cancel);
                        return;
                    }

                    if (value == false) {
                        passwordDialog();
                        return;
                    }
                    _confirm(1, continueFlow, passwordDialog);
                });
            };

            _isTouchIdAvailable(callback);
        }

        return {
            isTouchIdAvailable: _isTouchIdAvailable,
            verifyFingerprint: _verifyFingerprint
        };
    });
})