$(document).bind("mobileinit", function () {
    $.mobile.ajaxEnabled = false;
    $.mobile.linkBindingEnabled = false;
    $.mobile.hashListeningEnabled = false;
    $.mobile.pushStateEnabled = false;
    $.mobile.defaultHomeScroll = 0;
    $.mobile.orientationChangeEnabled = true;
    $.mobile.changePage.defaults.changeHash = false;

    $.mobile.loader.prototype.options.text = "";
    $.mobile.loader.prototype.options.textVisible = true;
    $.mobile.loader.prototype.options.theme = "a";
    $.mobile.loader.prototype.options.html = "";

    $.mobile.selectmenu.prototype.options.nativeMenu = false;

    // Setting #container div as a jqm pageContainer
    $.mobile.pageContainer = $('#main');
    // Setting default page transition to slide
    $.mobile.defaultPageTransition = 'slide';
    // Setting fallback transition for browsers that don't support 3D transforms
    $.mobile.transitionFallbacks.slideout = "none";

    // Saving original screen height to be used in the app
    window.orgScreenHeight = parseInt(window.innerHeight);

    // Remove page from DOM when it's being replaced
    $('div[data-role="page"],div[data-role="dialog"]').live('pagehide', function (event) {
        $(event.currentTarget).remove();
    });

    // Check if click event firing twice on same position.
    var lastclickpoint, curclickpoint, orgEvent;
    window.isJqmGhostClick = function (event) {
        orgEvent = event;
        curclickpoint = event.clientX + 'x' + event.clientY;
        if (lastclickpoint === curclickpoint) {
            lastclickpoint = '';
            return true;
        } else {
            lastclickpoint = curclickpoint;
            return false;
        }
    };

    var TAP_POINT_TOLERANCE = 5,
        TAP_TIME_TOLERANCE = 550;
    window.isJqmGhostClickPropagated = function (event) {
        var x = Math.abs(orgEvent.clientX - event.clientX),
            y = Math.abs(orgEvent.clientY - event.clientY),
            time = event.timeStamp - orgEvent.timeStamp;

        return x < TAP_POINT_TOLERANCE && y < TAP_POINT_TOLERANCE && time < TAP_TIME_TOLERANCE;
    };

    //Check if changePage is firing twice on event
    var timeStamp = null;
    var eventTarget = null;
    window.isChangePageFired = function (e) {
        window.AppProperties.TapEvent = { timestamp: e.timeStamp, target: e.currentTarget };

        if (ConfigHelper.isDeviceOnline() == false)
            window.AppProperties.TapEvent = null;

        var tapEvent = window.AppProperties.TapEvent;

        if (timeStamp && tapEvent && tapEvent.timestamp - timeStamp < 10000 && tapEvent.target == eventTarget) {
            return true;
        }

        if (window.AppProperties.TapEvent) {
            timeStamp = tapEvent.timestamp;
            eventTarget = tapEvent.target;
        }

        return false;
    };

    $.getJSON('js/versionInfo.json', function (versionInfo) {
        require(['shared_top_level/js/encode'], function () {
            $.ajaxSetup({
                timeout: 70000,
                beforeSend: function (xhr, settings) {

                    if (settings.url.indexOf(window.AppConfig.PassslotUri) < 0) {
                        xhr.setRequestHeader('Authorization', 'Basic ' + Encoder.base64Encode(appConfig.RESTAuth));
                        xhr.setRequestHeader('Content-Type', 'application/json; charset=utf-8');
                        xhr.setRequestHeader('WrapResponse', 'True');
                        xhr.setRequestHeader('AppVersion', versionInfo.versionNumber);
                    }

                    if (ConfigHelper.isDeviceOnline() === false && window.location.hash !== '' && window.location.hash !== '#home') {
                        xhr.abort();
                        window.hidePageLoadingMessage();
                        window.showAlert(window.ObjectCollections.Localization.result.errorUnableConnectToInternet);
                        return false;
                    }
                }
            });
        });
    });

});