define([  
    'text!templates/LoyaltyCardResetPasswordDialog.html',
    'sharedhelpers/configurationProvider',
    'sharedhelpers/utilities',
    'libs/jquery.validate.min',
    'sharedhelpers/encryptionHelper',
    'sharedhelpers/cultureHelper'
], function (template, configurationProvider) {
    var view = Backbone.View.extend({
        template: _.template(template),
        localize: window.ObjectCollections.Localization.result,

        initialize: function () {
            this.cultureHelper = new CultureHelper();
            this.emailValidation = this.cultureHelper.emailValidation();
        },

        render: function () {
            var self = this;
            $(this.el).html(this.template({localize: this.localize}));
            var retView = configurationProvider.arangeFlow(this);

            $.validator.addMethod('email', function (value) {
                return self.emailValidation.regex.test(value);
            }, self.emailValidation.msg);
            $.validator.addClassRules({ phone: { phone: true }, email: { email: true } });

            return $(retView.el);
        },

        events: {
            'tap #ok': 'resetPassword',
            'tap #cancel': 'cancel'
        },

        resetPassword: function(event){
            event.preventDefault();
            var that = this;
            var form = $("#frmLoyaltyCard");
            if (form.valid()) {
                window.showPageLoadingMessage();
                var email = $('#email').val();
                require(['models/loyaltyAccountModel'], function (loyaltyAccountModel) {
                    var model = new loyaltyAccountModel();
                    model.resetPass(email, function(result) {
                        if (result) {
                            window.hidePageLoadingMessage();
                            $('#popupDialog').popup('close');
                            showAlert(that.localize.loyaltyDialogPassResetSuccess);
                        }
                    }, function() {
                        window.hidePageLoadingMessage();
                    });
                });
            }
        },

        cancel: function (event) {
            event.preventDefault();
            $('#popupDialog').popup('close');
        }
    });

    return view;
});