﻿define([
    'sharedhelpers/configurationProvider',
    'text!templates/PurchaseHistoryTicketView.html'
], function (configurationProvider, template) {
    var view = Backbone.View.extend({
        template: _.template(template),
        localize: window.ObjectCollections.Localization.result,

        initialize: function () {
            this.nativeCalendarHelper = this.options.nativeCalendarHelper;
        },

        render: function (order) {
            var currentBusinessDate = Globalize.format(DtHelper.getCurrentBusinessDate(), 'yyyyMMdd');
            var orderBusinessDate = order.performance ? order.performance.businessDate : DtHelper.getBussinessDate(order.purchasedDateTime);

            var passbookIcon = typeof window.device != 'undefined' ? window.device.version.slice(0, window.device.version.indexOf('.')) : 11;
            var showRemoveButton = orderBusinessDate < currentBusinessDate;
            var showCalendarButton = this.nativeCalendarHelper.useCalendarPlugin();

            $(this.el).html(this.template({
                item: order,
                localize: this.localize,
                showRemoveButton: showRemoveButton,
                passbookIcon: passbookIcon,
                showCalendarButton: showCalendarButton,
                disableCalendarButton: order.addedToCalendar
            }));

            var retView = configurationProvider.arangeFlow(this);
            var date = order.performance ? order.performance.showTime : order.purchasedDateTime;

            if (new Date(date) < new Date() || !order.theaterDetails) {
                $(this.el).find('.ticket-pass').hide();
                $(this.el).find('.ios11-ticket-pass').hide();
            }
            if (order.giftedTicket) {
                this.renderQrCode(order);
            }
            return retView;
        },

        renderQrCode: function (item) {
            var qrSelector = $(this.el).find('[data-serialnumber="' + item.confirmationNumber + '"]:not(:has(.gift-icon))');
            var qrText = (item.patronsName && !configurationProvider.useSimpleQrCode()) ? item.confirmationNumber + '^' + item.patronsName : item.confirmationNumber;

            qrSelector.qrcode({ text: qrText });
            qrSelector.css({ 'left': '13%', 'bottom': '30%' });

            qrSelector.find('canvas').css({ "width": "100px", "height": "100px" });
        }
    });
    return view;
});
