define([
  'text!templates/ConcessionItemView.html',
  'views/pullDownStatusView'
], function (template, pullDownStatusView) {
    var view = Backbone.View.extend({
        template: _.template(template),
        localize: window.ObjectCollections.Localization.result,

        initialize: function () {
            window.tempHistoryCount++;

            this.pullDownStatusView = null;
        },

        events: {
            "tap .concessionItem": "onItemSelect",
            "tap .ui-btn-left": "removeItem"
        },

        onItemSelect: function (event) {
            event.preventDefault();
            if (isJqmGhostClickPropagated(event) || isJqmGhostClick(event) || isChangePageFired(event)) return;

            var that = this;

            var id = $(event.currentTarget).attr("data-item-id");
            var name = decodeURIComponent($(event.currentTarget).attr("data-item-name"));

            require(['helpers/concessionsHelper'], function () {
                var helper = new ConcessionsHelper();

                var selectedProduct = window.ObjectCollections.ConcessionCollection.products.where({ id: id })[0];
                var comboItem = selectedProduct.get('comboItems');

                if (comboItem && comboItem.length > 0) {
                    window.TempComboConcessionObject = { concessionItemId: helper.getGuid(), productId: id, quantity: 1, tax: selectedProduct.get('tax'), name: selectedProduct.get('name'), price: selectedProduct.get('price'), image: selectedProduct.get('image'), comboItems: [] };
                    window.ConcessionData.ComboItemProducts = [];
                    window.ConcessionData.CurrentComboTax = selectedProduct.get('tax');

                    for (var i = 0; i < comboItem.length; i++) {
                        var item = comboItem[i];
                        for (var j = 0; j < item.quantity; j++) {
                            window.ConcessionData.ComboItemProducts.push(item.products);
                        }
                    }

                    window.ConcessionData.ComboProductsCount = window.ConcessionData.ComboItemProducts.length;
                    window.ConcessionData.CurrentComboProduct += 1;

                    var productIds = window.ConcessionData.ComboItemProducts[0];
                    window.AppMethods.ChangePage('concessionItem/' + encodeURIComponent(name) + '/' + productIds + '/' + that.options.theaterCulture + '/' + new Date().getTime());
                } else {
                    if (window.ConcessionData.CurrentComboProduct == 0 && window.ConcessionData.ComboProductsCount > 0) {
                        helper.clearData();
                    }

                    helper.routeNext(selectedProduct, that.options.theaterCulture, name);
                }
            });
        },

        render: function () {
            this.$el.html(this.template({
                localize: this.localize,
                itemName: this.options.itemName,
                concessionItem: this.options.concessionItem,
                theaterCulture: this.options.theaterCulture
            }));

            this.pullDownStatusView = new pullDownStatusView();
            this.assign(this.pullDownStatusView, '.pullDownStatusHolder');

            return this;
        },

        assign: function (childView, selector) {
            this.$(selector).empty();
            childView.setElement(this.$(selector)).render();
            this.$(selector).enhanceWithin();
        },

        removeItem: function () {
            if (window.ConcessionData.CurrentComboProduct != 0) {
                window.ConcessionData.CurrentComboProduct -= 1;

                if (window.ConcessionData.CurrentComboProduct > 0) {
                    var prodId = window.ConcessionData.ComboItemProducts[window.ConcessionData.CurrentComboProduct - 1][0];
                    var selectedProduct = window.ObjectCollections.ConcessionCollection.products.where({ id: prodId })[0];
                    window.ConcessionData.ParentName = selectedProduct.get('name');
                }
            }
        }
    });

    return view;
});