define([
  'text!templates/ConcessionModifiersMultiView.html',
  'views/pullDownStatusView'
], function (template, pullDownStatusView) {
    var view = Backbone.View.extend({
        template: _.template(template),
        localize: window.ObjectCollections.Localization.result,

        initialize: function () {
            window.tempHistoryCount++;
            
            this.pullDownStatusView = null;
        },

        events: {
            "tap #addMultiOrderBtn": "addToOrder",
            "tap .ui-btn-left": "removeItem"
        },

        addToOrder: function (e) {
            e.preventDefault();
            if (isJqmGhostClick(e) || isChangePageFired(e)) return;

            var that = this;

            require(['helpers/concessionsHelper'], function () {
                var parentId = that.options.parentId;
                var product = window.ObjectCollections.ConcessionCollection.products.where({ id: parentId })[0];

                var helper = new ConcessionsHelper();
                var selectedConcession = helper.createSelectedItem(product, null);
                if (window.ConcessionData.ComboProductsCount == 0)
                    helper.updateTax(selectedConcession.tax);

                selectedConcession.modifiers = new Array();
                $("input:checkbox:checked").each(function () {
                    var productId = $(this).attr('id');
                    var modifier = window.ObjectCollections.ConcessionCollection.products.where({ id: productId })[0];
                    selectedConcession.modifiers.push({ quantity: 1, productId: modifier.get('id'), name: modifier.get('name'), tax: modifier.get('tax'), price: modifier.get('price'), image: modifier.get('image') });
                    if (modifier.get('price') != 0)
                        helper.updateTax(modifier.get('tax'));
                });
                helper.saveItem(selectedConcession);
                helper.routeNext(product, that.options.theaterCulture);
            });
        },

        render: function () {
            this.$el.html(this.template({
                multiModifiers: this.options.multiModifiers,
                theaterCulture: this.options.theaterCulture,
                localize: this.localize
            }));

            this.pullDownStatusView = new pullDownStatusView();
            this.assign(this.pullDownStatusView, '.pullDownStatusHolder');

            return this;
        },

        assign: function (childView, selector) {
            this.$(selector).empty();
            childView.setElement(this.$(selector)).render();
            this.$(selector).enhanceWithin();
        },

        removeItem: function () {
            require(['helpers/concessionsHelper'], function () {
                var helper = new ConcessionsHelper();
                helper.removeItem();
            });
        }
    });

    return view;
});