define([
  'text!templates/ConcessionModifiersSingleView.html',
  'views/pullDownStatusView'
], function (template, pullDownStatusView) {
    var view = Backbone.View.extend({
        template: _.template(template),
        localize: window.ObjectCollections.Localization.result,

        initialize: function () {
            window.tempHistoryCount++;
            
            this.pullDownStatusView = null;
        },

        events: {
            "tap .singleModifier": "onSingleModifierSelect",
            "tap .ui-btn-left": "removeItem"
        },

        onSingleModifierSelect: function (event) {
            var that = this;
            event.preventDefault();
            if (isJqmGhostClickPropagated(event) || isJqmGhostClick(event) || isChangePageFired(event)) return;

            require(['helpers/concessionsHelper'], function () {
                var id = $(event.currentTarget).attr("data-item-id");
                var product = window.ObjectCollections.ConcessionCollection.products.where({ id: id })[0];
                var parentProduct = {};
                var helper = new ConcessionsHelper();

                if (product) {
                    parentProduct = window.ObjectCollections.ConcessionCollection.products.where({ id: that.options.parentId })[0];

                    var selectedConcession = helper.createSelectedItem(parentProduct, product);
                    if (window.ConcessionData.ComboProductsCount == 0)
                        helper.updateTax(selectedConcession.tax);
                    helper.saveItem(selectedConcession);
                }

                helper.routeNext(parentProduct, that.options.theaterCulture);
            });
        },

        render: function () {
            var that = this;

            that.$el.html(this.template({
                singleModifiers: that.options.singleModifiers,
                theaterCulture: that.options.theaterCulture,
                localize: that.localize
            }));

            that.pullDownStatusView = new pullDownStatusView();
            that.assign(that.pullDownStatusView, '.pullDownStatusHolder');

            return that;
        },

        assign: function (childView, selector) {
            this.$(selector).empty();
            childView.setElement(this.$(selector)).render();
            this.$(selector).enhanceWithin();
        },

        removeItem: function () {
            require(['helpers/concessionsHelper'], function () {
                var helper = new ConcessionsHelper();
                helper.removeItem();
            });
        }
    });

    return view;
});