﻿define([
  'text!templates/CreatePassDialogView.html',
  'libs/jquery.validate.min',
  'helpers/paymentMethodHelper',
  'helpers/validationHelper'
], function (template) {
    var view = Backbone.View.extend({
        template: _.template(template),
        localize: window.ObjectCollections.Localization.result,

        initialize: function () {
            this.redirect = false;
        },

        render: function () {
            this.$el.html(this.template({
                localize: this.localize,
                model: this.options.model,
                dialogTopNotification: this.options.dialogTopNotification,
                dialogBottomNotification: this.options.dialogBottomNotification
            }));

            return $(this.el);
        },

        events:
		{
		    "tap #ok": "ok",
		    "tap #cancel": "cancel",
		    "keypress #pass": "handleKeypress",
            "keypress #repeatPass": "handleKeypress"
		},

        cancel: function (event) {
            event.preventDefault();

            this.options.callback(false);
            return false;
        },

        ok: function (event) {
            event.preventDefault();

            var self = this;
            var cardPassword = $("#pass").val();
            if (cardPassword) {
                window.ValidationHelper.validatePassword(cardPassword);
            }

            var form = $("#frmCreatePass");
            if (form.valid()) {
                var storage = new PaymentMethodsHelper();
                storage.saveAppPassword($("#pass").val(), function (response) {
                    if (response.success) {
                        self.options.callback(true);
                    }
                    else {
                        window.showAlert(this.localize.errorUnableToSavePassword);
                        return;
                    }
                });
            }
            //Stay on Dialog.
            return;
        },

        handleKeypress: function (event) {
            if (event.keyCode == 13) {
                event.preventDefault();
                this.ok(event);

                return;
            }
        }
    });

    return view;
});