﻿define([
  'text!templates/CreditCardsHolderView.html'
], function (template) {
    var view = Backbone.View.extend({
        template: _.template(template),
        localize: window.ObjectCollections.Localization.result,

        render: function () {
            var cards = this.options.cards;

            if (!this.options.acceptsSVC) {
                //Remove gift cards
                cards = _.filter(cards, function(card) {
                    return card.Type == 'CreditCard';
                });
            }

            this.$el.html(this.template({
                localize: this.localize,
                cards: cards,
                acceptsSVC: this.options.acceptsSVC
            }));
            return this;
        }
    });

    return view;
});