﻿define([
  'text!templates/EnterPassDialogView.html',
  'libs/jquery.validate.min',
  'helpers/paymentMethodHelper'
], function (template) {
    var view = Backbone.View.extend({
        template: _.template(template),
        localize: window.ObjectCollections.Localization.result,

        initialize: function () {
            var self = this;
            var storage = new PaymentMethodsHelper();

            $.validator.addMethod('pass', function (value) {
                return storage.validatePass(value, self.options.cinemaPass);
            }, this.localize.errorPasswordInvalid);

            this.redirect = false;
        },

        render: function () {
            this.$el.html(this.template({
                localize: this.localize,
                model: this.options.model
            }));

            return $(this.el);
        },

        events:
		{
		    "tap #ok": "ok",
		    "tap #cancel": "cancel",
		    "keypress #pass": "handlePassKeypress"
		},

        cancel: function (event) {
            event.preventDefault();

            this.options.callback(false);
            return false;
        },

        ok: function (event) {
            event.preventDefault();
            var form = $("#frmEnterPass");

            if (form.valid()) {
                this.options.callback(true);
            }

            return false;
        },

        handlePassKeypress: function (event) {
            if (event.keyCode == 13) {
                event.preventDefault();
                this.ok(event);

                return;
            }
        }
    });

    return view;
});