define(['text!templates/InfoDialog.html'], function (template) {
    window.InfoDialogView = Backbone.View.extend({
        render: function () {
            var that = this;
            $(this.el).html(_.template(template, { options: this.options }));

            $('#popupDialog').one('popupafterclose', function () {
                $(that.el).find('input').blur();
                $(that.el).unbind();
            });

            return $(this.el);
        },

        events: {
            "tap .dialog-button": "buttonHandler"
        },

        buttonHandler: function (e) {
            e.preventDefault();
            if (isJqmGhostClick(e)) return false;

            var buttonType = $(e.currentTarget).attr('data-id');
            if (this.options[buttonType] && this.options[buttonType].callback) {
                this.options[buttonType].callback();
            }
        }
    });

    return window.InfoDialogView;
});