﻿define([
  'text!templates/InputDialogView.html',
  'libs/jquery.validate.min'
], function (template) {
    var view = Backbone.View.extend({
        template: _.template(template),
        localize: window.ObjectCollections.Localization.result,

        render: function () {
            this.$el.html(this.template({ localize: this.localize }));

            return $(this.el);
        },

        events:
		{
		    "tap #ok": "ok",
		    "tap #cancel": "cancel",
		    "keypress #txtInput": "handleKeypress"
		},

        cancel: function (event) {
            event.preventDefault();

            $('#txtInput').blur();

            this.options.callback(false);
            return false;
        },

        ok: function (event) {
            event.preventDefault();
            
            if ($('#frmInputDialog').valid()) {
                var txtInput = $('#txtInput');

                txtInput.blur();
                this.options.callback(txtInput.val());
            }

            return false;
        },

        handleKeypress: function (event) {
            if (event.keyCode == 13) {
                event.preventDefault();
                this.ok(event);

                return;
            }
        }
    });

    return view;
});