define([
    'text!templates/MarqueeView.html',
    'idangerousSwiper'
], function (template) {
    var view = Backbone.View.extend({
        template: _.template(template),
        localize: window.ObjectCollections.Localization.result,

        render: function () {
            $(this.el).html(this.template({
                localize: this.localize,
                title: this.options.title,
                content: this.options.content,
                marqueeData: this.options.marqueeData
            }));

            var screenWidth = $(window).width();
            var screenHeight = $(window).height();

            $(this.el).find('#swiper-promotions').css({ 'max-width': screenWidth, 'max-height': screenHeight - 70 });
            $(this.el).find('.swiper-slide').css({ 'line-height': screenHeight + 'px' });
            $(this.el).find('.swiper-slide img').css({ 'max-width': screenWidth, 'max-height': screenHeight - 70 });

            _.defer(function () {
                $('.swiper-container').swiper({
                    mode: 'horizontal',
                    loop: true
                });
            });
        }
    });
    return view;
});