define([
    'text!templates/PurchaseHistoryOrderDetailsView.html'
], function (template) {
    var view = Backbone.View.extend({
        template: _.template(template),
        localize: window.ObjectCollections.Localization.result,

        events: {
            "pagehide": "onPageHide"
        },

        onPageHide: function () {
            window.AppProperties.HistoryOrderIndex = null;
        },

        render: function () {
            var selectedTickets = [];
            var ticketName = '';
            var seatsOrder = '';
            var counter = -1;
            var ticketQuantity = 0;
            var ticketPrice = 0;

            _.each(this.options.selectedTickets, function (ticket) {
                if (ticketName != ticket.name) {
                    ticketName = ticket.name;
                    ticketQuantity = 1;
                    seatsOrder = ticket.seatName;
                    ticketPrice = ticket.price;
                    selectedTickets.push({
                        ticketName: ticketName,
                        ticketQuantity: ticketQuantity,
                        seatsOrder: seatsOrder,
                        ticketPrice: ticketPrice,
                        tax:  ticket.tax
                    });
                    counter++;
                } else {
                    ticketQuantity++;
                    ticketPrice = ticketPrice + ticket.price;
                    seatsOrder = seatsOrder + ' ' + ticket.seatName;

                    selectedTickets[counter].ticketQuantity = ticketQuantity;
                    selectedTickets[counter].ticketPrice = ticketPrice;
                    selectedTickets[counter].tax = ticket.tax;
                    selectedTickets[counter].seatsOrder = seatsOrder;
                    selectedTickets[counter].ticketQuantity = ticketQuantity;
                }
            });

            $(this.el).html(this.template({
                selectedTickets: selectedTickets,
                movieName: this.options.movieName,
                performance: this.options.performance,
                theaterName: this.options.theaterName,
                displayNetTicketPrice: this.options.displayNetTicketPrice,
                tax: this.options.tax,
                subtotal: this.options.subTotal,
                totalPrice: this.options.totalPrice,
                concessions: this.options.concessions,
                otherItems: this.options.otherItems,
                theaterCulture: this.options.theaterCulture,
                purchasedDateTime: this.options.purchasedDateTime,
                localize: this.localize
            }));
        }
    });

    return view;
});