define([
    'text!templates/SelectSeatsZoneMapKeyView.html',
    'sharedhelpers/configurationProvider'
], function (template, configurationProvider) {
    window.SelectSeatsMapKeyView = Backbone.View.extend({
        localize: window.ObjectCollections.Localization.result,

        render: function () {
            $(this.el).html(_.template(template, {
                localize: this.localize,
                zones: this.options.zones,
                theater: this.options.theater,
                showLoveSeat: this.options.showLoveSeat,
                showCompanion: this.options.showCompanion,
                showWheelChair: this.options.showWheelChair,
                showRegular: this.options.showRegular,
                configurationProvider: configurationProvider
            }));

            return $(this.el);
        },

        events: {
            "tap #closeButton": "pageClose"
        },

        pageClose: function (event) {
            $('[data-role=content]').css({ 'pointer-events': '' });
            $('.pullDownStatusHolder').css({ 'pointer-events': '' });
            event.preventDefault();
            this.options.callback();

            return false;
        }
    });

    return window.SelectSeatsMapKeyView;
});