﻿define([
  'text!templates/VirtualGiftCardDialogView.html',
  'libs/jquery.validate.min',
  'sharedhelpers/utilities'
], function (template) {
    var view = Backbone.View.extend({
        template: _.template(template),
        localize: window.ObjectCollections.Localization.result,

        render: function () {
            var that = this;
            that.$el.html(that.template({
                localize: that.localize,
                cardName: that.options.cardName
            }));

            that.setUpValidation();

            $(that.el).find('#vgc-amount, #vgc-name').bind('keypress', function (e) {
                if (e.keyCode == 13) {
                    e.preventDefault();
                    that.ok(e);
                    return;
                }
            });

            if (window.AppProperties.IsIOS) {
                $('#popupDialog').popup({
                    afteropen: function () {
                        $(that.el).find('#vgc-name').focus();
                    }
                });
            }
            return this.$el;
        },

        events:
		{
		    'tap #ok': 'ok',
		    'tap #cancel': 'cancel'
		},

        setUpValidation: function () {
            $.validator.addMethod('virtualCard', function (value) {
                return value > 0 && /^\d*(\.\d{1,2})?$/.test(value);
            }, this.localize.errorVirtualGiftCardAmount);

            $(this.el).find("#frmVirtualGiftCard").validate({
                onkeyup: false,
                focusCleanup: true
            });
        },

        cancel: function (event) {
            event.preventDefault();
            $('#vgc-amount').blur();
            $('#vgc-name').blur();

            this.options.callback(false);
            return false;
        },

        ok: function (event) {
            event.preventDefault();
            var that = this;

            if ($("#frmVirtualGiftCard").valid()) {
                var utilities = new Utilities();
                var vgcAmount = $('#vgc-amount');
                var vgcName = $('#vgc-name');

                vgcAmount.blur();
                vgcName.blur();

                that.options.callback(vgcAmount.val(), vgcName.val() ? utilities.capitalize($.trim(vgcName.val())) : that.options.cardName);
            }

            return false;
        }
    });

    return view;
});