
window.HtmlHelper = {

    getStandards: function () {
        return [
            { key: "dolbySoundFlag", friendlyName: "DOLBY" },
            { key: "dTSSoundFlag", friendlyName: "DST" },
            { key: "sDDSSoundFlag", friendlyName: "SDDS" },
            { key: "tHXSoundFlag", friendlyName: "THX" },
            { key: "dDDFlag", friendlyName: "3D" },
            { key: "imaxFlag", friendlyName: "IMAX" },
       ];

    },

    getAsistiveExperiences: function(){
        return[
             { key: "closedCaptioningFlag", friendlyName: "CC" },
             { key: "audioDescriptionFlag", friendlyName: "AD" }
        ];
    },

    getCinemaStandards: function (performance) {
        if (performance == undefined)
            return [];

        var standards = this.getStandards();

        var supportedStandards = [];

        for (var i = 0; i < standards.length; i++) {
            var standard;

            try {
                standard = performance.get(standards[i].key);
            } catch (e) {
                standard = performance[standards[i].key];
            }

            if (standard != undefined && standard)
                supportedStandards.push(standards[i].friendlyName);
        }
        return supportedStandards;
    },

    getCinemaAssistiveExperiences:function(performance)
    {
        if (performance == undefined)
            return [];

        var experiences = this.getAsistiveExperiences();

        var supportedExperiences = [];

        for (var i = 0; i < experiences.length; i++) {
            var experience;

            try {
                experience = performance.get(experiences[i].key);
            } catch (e) {
                experience = performance[experiences[i].key];
            }

            if (experience != undefined && experience)
                supportedExperiences.push(experiences[i].friendlyName);
        }
        return supportedExperiences;

    },
    getCinemaAssitiveExperiencesFromPerformances:function(performances)
    {
        if (performances == undefined)
            return [];
          featureSupportedExperiences =  []; 
          _.each(performances, function (model) {

              var supportedExperiences = HtmlHelper.getCinemaAssistiveExperiences(model);

              for (var i = 0; i < supportedExperiences.length; i++) {
                  var found = jQuery.inArray(supportedExperiences[i], featureSupportedExperiences);
                  if (found < 0) {
                      // Element was not found, add it.
                      featureSupportedExperiences.push(supportedExperiences[i]);
                  }
              }

          });
          return featureSupportedExperiences;
      }


};


