define(["models/scheduleModel", 'sharedhelpers/errorHelper'], function (scheduleModel) {
    window.ScheduleCollection = BaseCollection.extend({
        model: scheduleModel,
        url: function () {
            return this.RESTUri + 'theaters/' + this.theaterId + '/schedule' + (this.businessDate ? "/" + this.businessDate : "") + (this.updateTimestamp ? "/updatetimestamp/" + this.updateTimestamp : "");
        },
        parse: function (resp) {
            this.result_code = resp.result_code;

            //TODO: Stupid thing, need to do string comparison because of the response we are currently getting from the API
            if (resp.result == 'You already have the latest schedule')
                return {
                    scheduleUpToDate: true
                };
           
            if (resp.result && resp.result.features) {
                return resp.result.features;
            }

            return resp.result;
        },
        initialize: function (arg) {
            if (arg) {
                this.theaterId = arg.theaterId;
            }
        },
        strategies: {
            byName: function (schedule) { return schedule.get('name'); }
        },
        //TODO: Add updateTimestamp parameter to this function but first handle all the calls from all the applications that are currently using this function
        getTheaterSchedule: function (businessDate, successCallback, errorCallback) {
            var that = this;
            this.businessDate = businessDate;

            return this.fetch({
                success: function (result) {
                    result.comparator = that.strategies['byName'];
                    result.sort();
                    successCallback(result);
                },
                error: function (model, xhr) {
                    if (errorCallback)
                        errorCallback(model, xhr);
                }
            });
        },
        //TODO: Remove this function after the todo from above is finished
        getTheaterScheduleTimestamp: function (businessDate, updateTimestamp, successCallback, errorCallback) {
            var that = this;
            this.businessDate = businessDate;
            this.updateTimestamp = updateTimestamp;

            return this.fetch({
                success: function (result) {
                    result.comparator = that.strategies['byName'];
                    result.sort();
                    successCallback(result);
                },
                error: function (model, xhr) {
                    if (errorCallback)
                        errorCallback(model, xhr);
                }
            });
        },
        getMovieAndPerformance: function (movieCode, performanceId) {
            var perf = null;
            var movie = null;

            if (movieCode, performanceId) {
                _.each(this.models, function (feature) {
                    if ($.trim(feature.get('code')) == $.trim(movieCode)) {
                        movie = feature;
                        _.each(feature.get('performances').models, function (performance) {
                            if (performance.get('number') == performanceId) {
                                perf = performance;
                            }
                        });
                    }
                });
            }
            return { performance: perf, movie: movie };
        }
    });

    return window.ScheduleCollection;
});