﻿define([], function () {
    window.AddItemModel = BaseModel.extend({
        url: function (termId) {
            return appConfig.AlohaApiUrl + termId + '/AlohaEntities/PostCommand';
        },

        postTicketSale: function (termId, orderModel, saleResult, callback) {
            var that = this;
            var alCom = {
                currentCommandType: 3,
                addItemValue: {
                    termId: parseInt(window.AppProperties.TermID, 10),
                    checkId: parseInt(window.AppProperties.CheckID, 10),
                    itemToAdd: {
                        itemId: parseInt(saleResult.tickets[0].alohaItemId, 10),
                        name: orderModel.get('movie').get('name'),
                        price: 0,
                        modifiers: []
                    }
                }
            };
            
             _.each(saleResult.tickets, function (t) {

                var m = {
                    itemId: parseInt(t.alohaModifierId, 10),
                    openModifierName: t.name,
                    modifierPrice: t.price,units: 1
                };
                
                alCom.addItemValue.itemToAdd.modifiers.push(m);
            });
            $.ajax({
                url: 'http://localhost:29217/api/AlohaComand/AlohaCommandPost',
                type: 'POST',
                data: JSON.stringify(alCom),
                success: function () {
                    if (callback)
                        callback(true);
                }, error: function () {
                    if(callback){
                        callback(false);
                    }
                }
            });
        }
    });

    return window.AddItemModel;
})

//define(['ByteBuffer', 'ProtoBuf', 'sharedjs/helpers/utilities'], function (ByteBuffer,ProtoBuf) {
//    window.AddItemModel = BaseModel.extend({
//        url: function (termId) {
//            return appConfig.AlohaApiUrl + termId + '/AlohaEntities/PostCommand';
//        },
//        encode: function (data) {
//            var str = String.fromCharCode.apply(null, data);
//            return btoa(str).replace(/.{76}(?=.)/g, '$&\n');
//        },
//        getAuthentication: function (callback) {
//            var that = this;
//            debugger;
//            var builder = ProtoBuf.newBuilder({ convertFieldsToCamelCase: true });
//            ProtoBuf.loadProtoFile("shared_kiosk/js/aloha_commands/AlohaEncryption.proto", builder);
//            var root = builder.build();
//            $.ajax({
//                url: 'http://localhost:29217/api/NcrCryptoService/GetRSAPublicKeyString',
//                type: 'GET',
//                success: function (result) {
//                    var authenticationDto = new root.Aloha.Encryption.AuthenticationDto();
//                    var symetricKeyDTO = new root.Aloha.Encryption.GetSymetricKeyDto();

//                    authenticationDto.producerId = new Utilities().createGuid();
//                    authenticationDto.clientToken = appConfig.AlohaEncryptionClientToken;
//                    authenticationDto.publicKey = result

//                    that.sessionGUID = authenticationDto.producerId;

//                    symetricKeyDTO.encryptionVersion = appConfig.AlohaDefaultEncryptVersionNumber;

//                    var authenticationDtoBytes= new Uint8Array(authenticationDto.encode().buffer);

//                    var authenticationDtoBas64String = that.encode(authenticationDtoBytes);
//                    var salt = that.encode(appConfig.AlohaEncryptionSalt);

//                    $.ajax({
//                        url: 'http://localhost:29217/api/NcrCryptoService/EncryptStuff',
//                        type: 'POST',
//                        data: $.sprintf("{authenticationDto:'%s', password:'%s', salt:'%s', passwordIterations: %s }", authenticationDtoBas64String, new Utilities().decrypt(appConfig.AlohaEncryptionPassword), salt, appConfig.AlohaPasswordIterations),
//                        success: function (result) {
//                            var byteCharacters = atob(result);
//                            var byteNumbers = new Array(byteCharacters.length);
//                            for (var i = 0; i < byteCharacters.length; i++) {
//                                byteNumbers[i] = byteCharacters.charCodeAt(i);
//                            }

//                            var dataPayload = new root.Aloha.Encryption.DataPayloadDto();
//                            dataPayload.payload = new ByteBuffer.fromBase64(result);
//                            symetricKeyDTO.dataPayload = dataPayload;

//                            var buffer = symetricKeyDTO.encode();
//                            var byteArray = new Uint8Array(buffer.buffer);

//                            var xhr = new XMLHttpRequest();
//                            xhr.open('POST', appConfig.AlohaApiUrl + "Authorize", true);
//                            xhr.setRequestHeader('content-type', 'application/octet-stream');
//                            xhr.setRequestHeader('NCRProtoBufType', 'Aloha.Encryption.GetSymetricKeyDto');
//                            xhr.setRequestHeader('NCRProducerGUID', authenticationDto.producerId);

//                            xhr.onload = function (response) {
//                                window.LoggerHelper.logDebug("symetricKeyDTO Aloha pos response: " + JSON.stringify(this.response), window.LoggerHelper.loggingScopes.Kiosk);

//                                that.returnSymetricKeyDto = new root.Aloha.Encryption.ReturnSymetricKeyDto();
//                                that.returnSymetricKeyDto.encryptedKey = this.response;
//                                callback(true);
//                            };
//                            xhr.error = function () {
//                                window.LoggerHelper.logDebug("Error fetching the key");
//                                callback(false);
//                            }
//                            xhr.send(byteArray);
//                        },
//                        error: function(){
//                            window.LoggerHelper.logDebug("Error encrypting on device service");
//                        }
//                    });
//                },
//                error: function(){
//                    window.LoggerHelper.logDebug("Error getting public key from the device service");
//                }
//            });
//        },
//        postTicketSale: function (termId, orderModel, saleResult, callback) {
//            var that = this;
//            require(['ProtoBuf'], function (ProtoBuf) {
//                that.getAuthentication(function (response) {
//                    if (response) {
//                        var builder = ProtoBuf.newBuilder({ convertFieldsToCamelCase: true });
//                        ProtoBuf.loadProtoFile("shared_kiosk/js/aloha_commands/AlohaEntities.proto", builder);
//                        ProtoBuf.loadProtoFile("shared_kiosk/js/aloha_commands/AlohaCommandsWrapper.proto", builder);
//                        ProtoBuf.loadProtoFile("shared_kiosk/js/aloha_commands/AlohaCommands.proto", builder);
//                        ProtoBuf.loadProtoFile("shared_kiosk/js/aloha_commands/AlohaEncryption.proto", builder);
//                        var root = builder.build();

//                        var allohaCommand = new root.Aloha.Commands.AlohaCommand();

//                        allohaCommand.currentCommandType = 3;
//                        allohaCommand.addItemValue = new root.Aloha.Commands.AddItemCommand();

//                        allohaCommand.addItemValue.termId = parseInt(window.AppProperties.TermID, 10);
//                        allohaCommand.addItemValue.checkId = parseInt(window.AppProperties.CheckID, 10);
//                        allohaCommand.addItemValue.itemToAdd = new root.Aloha.Commands.ItemToAddDto();

//                        allohaCommand.addItemValue.itemToAdd.itemId = parseInt(saleResult.tickets[0].alohaItemId, 10);
//                        allohaCommand.addItemValue.itemToAdd.name = orderModel.get('movie').get('name');
//                        allohaCommand.addItemValue.itemToAdd.price = saleResult.receipt.total;

//                        var lockedTickets = orderModel.get('tickets').getTicketsForLock();
//                        var filteredReceipt = orderModel.get('tickets').filterReceipt(saleResult.receipt.items, lockedTickets);

//                        _.each(filteredReceipt.models, function (t) {
//                            var modifier = new root.Aloha.Commands.ModifierToAddDto();

//                            modifier.itemId = parseInt(t.get('alohaModifierId'), 10);
//                            modifier.openModifierName = t.get('name');
//                            modifier.units = t.get('quantity');
//                            modifier.modifierPrice = t.get('price');

//                            allohaCommand.addItemValue.itemToAdd.modifiers.push(modifier);
//                        });

//                        var buffer = allohaCommand.encode();
//                        var byteArray = new Uint8Array(buffer.buffer);

//                        $.ajax({
//                            url: 'http://localhost:29217/api/NcrCryptoService/EncryptStuff',
//                            type: 'POST',
//                            data: $.sprintf("{authenticationDto:'%s', password:'%s', salt:'%s', passwordIterations: %s }", that.encode(byteArray), that.encode(that.returnSymetricKeyDto.encryptedKey), "", 10240),
//                            success: function (result) {
//                                var byteCharacters = atob(result);
//                                var byteNumbers = new Array(byteCharacters.length);
//                                for (var i = 0; i < byteCharacters.length; i++) {
//                                    byteNumbers[i] = byteCharacters.charCodeAt(i);
//                                }

//                                var xhr = new XMLHttpRequest();
//                                xhr.open('POST', that.url(termId), true);

//                                xhr.setRequestHeader('content-type', 'application/octet-stream');
//                                xhr.setRequestHeader('NCRProtoBufType', 'Aloha.Commands.AlohaCommand');

//                                xhr.responseType = 'application/octet-stream';

//                                xhr.onload = function () {
//                                    window.LoggerHelper.logDebug("Aloha pos response: " + JSON.stringify(this.response), window.LoggerHelper.loggingScopes.Kiosk);

//                                    if (callback)
//                                        callback(this.response);
//                                };

//                                xhr.send(byteNumbers);
//                            }
//                        });

//                    } else {
//                        if (callback)
//                            callback(false);
//                    }
//                })

//            });
//        }
//    });

//    return window.AddItemModel;
//})